#define DEBUG				printf("File: %s, Line: %d\n", __FILE__, __LINE__);

#define TRUE				1
#define FALSE				0

#define LINGER_TIMEO			500

#define THREADPOOL_CONTROL_LOOP		3

enum working_status {
	STAT_TERMINATED =	-2,
	STAT_INIT =		-1,
	STAT_SLEEPING =		0,
	STAT_WORKING =		1,
};

typedef enum working_status	thread_stat_t;
typedef enum working_status	working_stat_t;

typedef union {
	struct sockaddr		sa;
	struct sockaddr_in	sa_in;
} sock_addr;

typedef struct {
	int			port;
	int			listen_fd;
} attr_server;

struct thread_t {
	pthread_t		thread;
	pthread_mutex_t		mutex;
	pthread_cond_t		cond;

	thread_stat_t		status;
	int			sockfd;
};


struct mime_t {
	unsigned int		ext_len;		//Ȯ 
	char			*ext;			//Ȯ
	char			*content_type;		//ȭ Ÿ
	short			static_content;		// (cgi )
};

