#define DEFAULT_CONFIG_PORT			80

#define	DEFAULT_CONFIG_THREAD_POOL_SIZE		32
#define	DEFAULT_CONFIG_LISTEN_BACKLOG		100
#define	DEFAULT_CONFIG_TIMEOUT			4

#define	DEFAULT_CONFIG_DEFAULT_BUF_SIZE		"8K"

#define DEFAULT_CONFIG_FILE_CONFIG		"nhttpd.conf.xml"
#define DEFAULT_CONFIG_FILE_MIME		"mime.types"

#define DEFAULT_CONFIG_DEFAULT_CHARSET		"ISO-8859-1"

#define DEFAULT_CONFIG_SERVER_USER		"nobody"

#define DEFAULT_CONFIG_DOCUMENT_ROOT		"docs"
#define DEFAULT_CONFIG_DIRECTORY_INDEX		"index.html"

#define	DEFAULT_CONFIG_LOG_PATH			"logs"

//virtual host struct
struct vhost_t
{
	char			*host;
	int			port;
	char			*document_root;

	int			host_len;
};

//configuration struct
struct config_t
{
	char			*id;

	int			*port;
	int			port_len;

	unsigned int		thread_pool_size;	//max thread pool size, minimum is 2
	unsigned int		listen_backlog;		//listen backlog option
	unsigned int		timeout;		//client timeout

	unsigned long		default_buffer_size;

	char			*file_config;
	char			*file_mime;

	char			*default_charset;

	char			*server_user;
	char			*document_root;
	char			**directory_index_file;
	int			directory_index_len;

	int			vhost_len;
	struct vhost_t		*vhost;
};


void config_cleanup( struct config_t *config );
int parse_config( const int argc, char * const argv[], struct config_t *config );

