#include <header.h>

/*  ʱȭ */
attr_server *sock_init( sock_addr *sa, int port, int listen_backlog )
{
	attr_server	*hs;

	hs = malloc( sizeof(attr_server) * 1 );
	if ( hs == (attr_server *) 0 )
		return (attr_server *) 0;

	hs->port = port;

	if ( sa == (sock_addr *) 0 )
		hs->listen_fd = -1;
	else
	{
		sa->sa.sa_family = AF_INET;
		sa->sa_in.sin_addr.s_addr = htonl( INADDR_ANY );
		sa->sa_in.sin_port = htons( port );
		hs->listen_fd = initialize_socket( sa, listen_backlog );
	}

	if ( hs->listen_fd == -1)
	{
		free( hs );
		return (attr_server *) 0;
	}

	return hs;
}

/*  ʱȭ */
int initialize_socket( sock_addr *sa, int listen_backlog )
{
	int	listen_fd;
        int	on, flags;

        listen_fd = socket( sa->sa.sa_family, SOCK_STREAM, 0 );

        if ( listen_fd < 0 )
                return -1;

	(void) fcntl( listen_fd, F_SETFD, 1 );
        (void) fcntl( listen_fd, F_SETFL, O_NONBLOCK);
        on = 1;
        (void) setsockopt( listen_fd, SOL_SOCKET, SO_REUSEADDR, (char*) &on, sizeof(on) );
        if ( bind( listen_fd, &sa->sa, sizeof(struct sockaddr_in) ) < 0 )
        {
                (void) close( listen_fd );
                return -1;
        }

        flags = fcntl( listen_fd, F_GETFL, 0 );
        if ( flags == -1 )
        {
                (void) close( listen_fd );
                return -1;
        }

        if ( fcntl( listen_fd, F_SETFL, flags | O_NDELAY ) < 0 )
        {
                (void) close( listen_fd );
                return -1;
        }

	if ( listen( listen_fd, listen_backlog ) < 0 )
        {
                (void) close( listen_fd );
                return -1;
        }

        return listen_fd;
}

