#include <header.h>

/* ð */
char date_822[48];

/* û   */
const int http_request_headers_count = 11;

/* û  */
static char *http_request_headers[]={
	"Accept-Charset",
	"Accept-Language",
	"Accept-Ranges",
	"Content-Length",
	"Connection",
	"Accept:",
	"Accept-Encoding",
	"If-Modified-Since",
	"Referer",
	"User-Agent",
	"Host"
};

/* û   */
static int http_request_headers_len[]={
	14,15,13,14,10,7,15,17,7,10,4
};

/* û  ó Լ  迭 */
int (*http_request_headers_func[]) ( struct http_request_header_t *header, char *buf )={
	http_request_parse_accept_charset,
	http_request_parse_accept_language,
	http_request_parse_accept_ranges,
	http_request_parse_content_length,
	http_request_parse_connection,
	http_request_parse_accept,
	http_request_parse_accept_encoding,
	http_request_parse_if_modified_since,
	http_request_parse_referer,
	http_request_parse_user_agent,
	http_request_parse_host
};

/* HTTP û  ɴ */
short http_request_end( char *buf, int read_len )
{
	if ( read_len <= 1 )
		return FALSE;

	if ( strstr( buf, "\n\n" ) != NULL || strstr( buf, "\r\n\r\n" ) != NULL || ( buf[0] == '/' && strstr( buf, "\n" ) != NULL ) )
		return TRUE;

	return FALSE;
}

/* HTTP û pre parse Ѵ. û ޽, URL,    Ѵ */
int http_request_preparse( struct http_request_header_t *header, char *buf, int buf_len )
{
	/* header  bzero Ǿ ־  */
	short search_idx = 0;
	short cur_idx = 0;
	short token_idx = 0;
	
	if ( buf == (char *) 0 || buf[0] == ' ' || buf[0] == '\r' || buf[0] == '\n' )
		return -1;

	if ( buf[0] == '/' )
	{
		header->method = HTTP_METHOD_GET;
		header->protocol = 9;
		header->encoded_url = buf;
		while ( search_idx < buf_len )
		{
			search_idx++;
			if ( buf[search_idx] == ' ' || buf[search_idx] == '\r' || buf[search_idx] == '\n' ) 
			{
				buf[search_idx] = '\0';
				break;
			}
		}
	}
	else
	{
		while ( search_idx < buf_len )
		{
			search_idx++;
			if ( buf[search_idx] == ' ' || buf[search_idx] == '\r' || buf[search_idx] == '\n' )
			{
				if ( token_idx == 0 )
				{
					//header->method = &(buf[cur_idx]);
					if ( strncasecmp( &(buf[cur_idx]), "GET", 3 ) == 0 )
						header->method = HTTP_METHOD_GET;
					else if ( strncasecmp( &(buf[cur_idx]), "POST", 3 ) == 0 )
						header->method = HTTP_METHOD_POST;
					else if ( strncasecmp( &(buf[cur_idx]), "HEAD", 4 ) == 0 )
						header->method = HTTP_METHOD_HEAD;
					else
						return -1;

					cur_idx = search_idx+1;
				}
				else if ( token_idx == 1 )
				{
					header->encoded_url = &(buf[cur_idx]);
					cur_idx = search_idx+1;
					if ( &(buf[cur_idx]) == (char *) 0 )
						return -1;
					else if ( buf[cur_idx] != 'H' )
					{
						header->protocol = 9;
						break;
					}
				}
				else if ( token_idx == 2 )
				{
					if ( strncasecmp( &(buf[cur_idx]), HTTP_PROTOCOL_11, 8 ) == 0 )
						header->protocol = 11;
					else if ( strncasecmp( &(buf[cur_idx]), HTTP_PROTOCOL_10, 8 ) == 0 )
						header->protocol = 10;
					else
						return -1;
					cur_idx = search_idx+1;
				}
				token_idx++;
				buf[search_idx] = '\0';
				if ( token_idx > 2 )
					break;
			}
		}
	}
	//printf("method: %s\nurl: %s\nprotocol: %d\n", header->method, header->encoded_url, header->protocol);
	search_idx++;
	while ( search_idx < buf_len && ( buf[search_idx] == '\r' || buf[search_idx] == '\n' ) )
		search_idx++;

	header->query = strchr( header->encoded_url, '?' );
	if ( header->query != NULL )
	{
		header->query[0]='\0';
		header->query++;
	}
	http_decode_url( header->decoded_url, header->encoded_url );

	//printf("%s\n",header->decoded_url);
		
	return search_idx;
}

/* HTTP û  óѴ */
int http_request_parse( struct http_request_header_t *header, char *buf, int buf_len, int offset )
{
	int	i,
		idx;

	while (offset < buf_len)
	{
		while ( buf[offset] == '\r' || buf[offset] == '\n' || buf[offset] == ' ' || buf[offset] == '\0' )
		{
			offset++;
			continue;
		}

		idx=offset;
		while ( buf[idx] != '\r' && buf[idx] != '\n' && buf[idx] != '\0' && idx<buf_len )
			idx++;

		if (idx >= buf_len)
			break;
			
		buf[idx]='\0';

		for (i=http_request_headers_count; i--;)
		{
			if ( strncasecmp( &(buf[offset]), (http_request_headers[i]), (int) (http_request_headers_len[i]) ) == 0 )
			{
				/* HTTP û ó Լ  ȣ */
				http_request_headers_func[i]( header, &(buf[offset+http_request_headers_len[i]]) );
				break;
			}
		}
		offset=idx;
	}
	return 0;
}

/* keep alive  θ ϰ Ѵ */
short http_keep_alive( struct http_request_header_t *request_header, struct http_response_header_t *response_header, int timeout )
{
	if ( request_header == (struct http_request_header_t *) 0 || request_header->protocol < 11 )
		return FALSE;

	if ( request_header->connection != (char *) 0 && strncasecmp( request_header->connection, "Keep-Alive", 10 ) == 0 )
	{
		response_header->connection = TRUE;
		response_header->keep_alive = timeout;
		response_header->flags = response_header->flags|HTTP_RESPONSE_KEEP_ALIVE;
		return TRUE;
	}

	return FALSE;
}

/* content length  Ѵ */
void http_content_length( struct http_response_header_t *response_header, int content_length )
{
	response_header->content_length = content_length;
	response_header->flags = response_header->flags|HTTP_RESPONSE_CONTENT_LENGTH;
	return;
}

/* last modified  Ѵ */
void http_last_modified( struct http_response_header_t *response_header, time_t mktime )
{
	struct tm       time_s;

	localtime_r( &mktime, &time_s );
	strftime( response_header->last_modified, 64, "%a, %d %b %G %k:%M:%S GMT", &time_s );

	response_header->flags = response_header->flags|HTTP_RESPONSE_LAST_MODIFIED;
	return;
}

void http_content_type( struct http_request_header_t *request_header, struct http_response_header_t *response_header )
{
	response_header->content_type = mime_type( request_header );
	response_header->flags = response_header->flags|HTTP_RESPONSE_CONTENT_TYPE;
	return;
}

/* Ŭ̾Ʈ  Ѵ */
int http_response_send( struct http_response_header_t *header, short protocol, int sockfd )
{
	char	*buf;
	char	*stat_code;
	int	buf_len;

	if ( protocol < 10 )
		return 0;

	buf = malloc( HTTP_RESPONSE_HEADER_SIZE );
	stat_code = http_status_code( header->status );
	if ( stat_code == (char *) 0 )
	{
		header->status = 403;
		stat_code = HTTP_RESPONSE_STAT_403;
	}

	buf_len = snprintf( buf, HTTP_RESPONSE_HEADER_SIZE, "HTTP/1.1 %d %s\r\nDate: %s\r\nServer: %s\r\n", header->status, stat_code, (char *) &date_822, HTTP_SERVER_SOFTWARE );

	if ( header->flags&HTTP_RESPONSE_CONTENT_LENGTH )
		buf_len += snprintf( &(buf[buf_len]), HTTP_RESPONSE_HEADER_SIZE-buf_len, "Content-Length: %d\r\n", header->content_length );

	if ( header->flags&HTTP_RESPONSE_LAST_MODIFIED )
		buf_len += snprintf( &(buf[buf_len]), HTTP_RESPONSE_HEADER_SIZE-buf_len, "Last-Modified: %s\r\n", header->last_modified );

	if ( header->flags&HTTP_RESPONSE_KEEP_ALIVE )
		buf_len += snprintf( &(buf[buf_len]), HTTP_RESPONSE_HEADER_SIZE-buf_len, "Keep-Alive: timeout=%d\r\nConnection: Keep-Alive\r\n", header->keep_alive );
	else
		buf_len += snprintf( &(buf[buf_len]), HTTP_RESPONSE_HEADER_SIZE-buf_len, "Connection: close\r\n" );

	if ( header->flags&HTTP_RESPONSE_CONTENT_TYPE )
		buf_len += snprintf( &(buf[buf_len]), HTTP_RESPONSE_HEADER_SIZE-buf_len, "Content-Type: %s\r\n", header->content_type );

	buf_len += snprintf( &(buf[buf_len]), HTTP_RESPONSE_HEADER_SIZE-buf_len, "\r\n" );

	//printf("%s", buf);

	if ( send_response( sockfd, buf, buf_len ) < 0 )
	{
		free( buf );
		return -1;
	}

	free( buf );

	return 0;
}

/*  ¿   ڿ Ѵ */
char *http_status_code( short status )
{
	switch ( status )
	{
		case 200:	return HTTP_RESPONSE_STAT_200;
		case 304:	return HTTP_RESPONSE_STAT_304;
		case 400:	return HTTP_RESPONSE_STAT_400;
		case 401:	return HTTP_RESPONSE_STAT_401;
		case 403:	return HTTP_RESPONSE_STAT_403;
		case 404:	return HTTP_RESPONSE_STAT_404;
	}

	return (char *) 0;
}

/*     ڿ Ѵ */
char *http_protocol( short protocol )
{
	if ( protocol == 10 )
		return HTTP_PROTOCOL_10;
	else
		return HTTP_PROTOCOL_11;
}

void http_make_date( time_t now )
{
	struct tm	time_s;
	gmtime_r( &now, &time_s );
	strftime( date_822, 48, "%a, %d %b %G %k:%M:%S GMT", &time_s );
}

/* accept_charset Ľ */
int http_request_parse_accept_charset( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->accept_charset = buf;
	return 0;
}
/* accept language Ľ */
int http_request_parse_accept_language( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->accept_language = buf;
	return 0;
}
/* accept ranges Ľ */
int http_request_parse_accept_ranges( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->accept_ranges = buf;
	return 0;
}
/* content_length Ľ */
int http_request_parse_content_length( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->content_length = atoi(buf);
	return 0;
}
/* connection Ľ */
int http_request_parse_connection( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->connection = buf;
	return 0;
}
/* accept Ľ */
int http_request_parse_accept( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->accept = buf;
	return 0;
}
/* accept encoding Ľ */
int http_request_parse_accept_encoding( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->accept_encoding = buf;
	return 0;
}
/* if modified since Ľ */
int http_request_parse_if_modified_since( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->if_modified_since = http_asctime2time_t( buf );
	return 0;
}
/* referer Ľ */
int http_request_parse_referer( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->referer = buf;
	return 0;
}
/* user agent Ľ */
int http_request_parse_user_agent( struct http_request_header_t *header, char *buf )
{
	buf += strspn( buf, ": " );
	header->user_agent = buf;
	return 0;
}
/* host Ľ */
int http_request_parse_host( struct http_request_header_t *header, char *buf )
{
	char	*port;

	buf += strspn( buf, ": " );
	header->host = buf;
	port = strchr( buf, ':' );
	if ( port != NULL )
	{
		port[0] = '\0';
		port++;
		header->port = atoi( port );
	}
	header->host_len = strlen( header->host );
	return 0;
}

/* ڿ  ð timestamp ȯѴ */
time_t http_asctime2time_t( char *asctime )
{
	int             asc_len;
	struct tm       time;
	short           flag = 0;

	asc_len = strlen( asctime );

	time.tm_wday = time.tm_yday = time.tm_isdst = 0;

	if ( asc_len <= 24 )
	{
		/*Sun Nov 6 08:49:30 1994         ; ANSI C's asctime() format*/
		time.tm_year =  atoi( &(asctime[( asc_len - 4 )]) ) - 1900;
		asctime[( asc_len - 5 )] =      '\0';
		time.tm_sec =   atoi( &(asctime[( asc_len - 7 )]) );
		time.tm_min =   atoi( &(asctime[( asc_len - 10 )]) );
		time.tm_hour =  atoi( &(asctime[( asc_len - 13 )]) );
		asctime[( asc_len - 14 )] =     '\0';
		asctime[7] =    '\0';
		time.tm_mon =   http_ascmon2int( &(asctime[4]) );
		time.tm_mday =  atoi( &(asctime[8]) );
		flag = 1;
	}
	else if ( asc_len == 29 )
	{
		/*Sun, 06 Nov 1994 08:49:30 GMT   ; RFC 822, updated by RFC 1123*/
		//IE  ַ   !
		if ( memcmp( &(asctime[( asc_len - 3 )]), "GMT", 3 ) == 0 )
		{
			time.tm_mday =  atoi( &(asctime[5]) );
			time.tm_mon =   http_ascmon2int( &(asctime[8]) );
			asctime[16] = '\0';
			time.tm_year =  atoi( &(asctime[12]) ) - 1900;
			time.tm_hour =  atoi( &(asctime[17]) );
			time.tm_min =   atoi( &(asctime[20]) );
			time.tm_sec =   atoi( &(asctime[23]) );
			flag =1;
		}
	}
	else if ( asc_len < 36 )
	{
		/*Sunday, 06-Nov-94 08:49:30 GMT  ; RFC 850, obsoleted by RFC 1036*/
		if ( memcmp( &(asctime[( asc_len - 3 )]), "GMT", 3 ) == 0 )
		{
			time.tm_sec =   atoi( &(asctime[( asc_len - 6 )]) );
			time.tm_min =   atoi( &(asctime[( asc_len - 9 )]) );
			time.tm_hour =  atoi( &(asctime[( asc_len - 12 )]) );
			asctime[( asc_len - 13 )] = '\0';
			time.tm_year =  atoi( &(asctime[( asc_len - 15 )]) );
			time.tm_mon =   http_ascmon2int( &(asctime[( asc_len - 19 )]) );
			time.tm_mday =  atoi( &(asctime[( asc_len - 22 )]) );
			flag =1;
		}
	}

	return mktime(&time);
}

/* ڿ  "" ڷ ȯѴ */
int http_ascmon2int( char *ascmonth )
{
	if ( memcmp( ascmonth, "Jan", 3 ) == 0 )       return 0;
	else if ( memcmp( ascmonth, "Feb", 3 ) == 0 )  return 1;
	else if ( memcmp( ascmonth, "Mar", 3 ) == 0 )  return 2;
	else if ( memcmp( ascmonth, "Apr", 3 ) == 0 )  return 3;
	else if ( memcmp( ascmonth, "May", 3 ) == 0 )  return 4;
	else if ( memcmp( ascmonth, "Jun", 3 ) == 0 )  return 5;
	else if ( memcmp( ascmonth, "Jul", 3 ) == 0 )  return 6;
	else if ( memcmp( ascmonth, "Aug", 3 ) == 0 )  return 7;
	else if ( memcmp( ascmonth, "Sep", 3 ) == 0 )  return 8;
	else if ( memcmp( ascmonth, "Oct", 3 ) == 0 )  return 9;
	else if ( memcmp( ascmonth, "Nov", 3 ) == 0 )  return 10;
	else if ( memcmp( ascmonth, "Dec", 3 ) == 0 )  return 11;
	return -1;
}

/* ڵ URL ڵ Ѵ */
void http_decode_url( char *to, char *from )
{
	for ( ; *from != '\0'; ++to, ++from )
	{
		if ( from[0] == '%' && isxdigit( from[1] ) && isxdigit( from[2] ) )
		{
			*to = http_hexit( from[1] ) * 16 + http_hexit( from[2] );
			from += 2;
		}else{
			*to = *from;
		}
	}
	*to = '\0';
}

/* û   ../../ ó ȿ    ΰ  ش */
void http_de_dotdot( char *file )
{
	char    *cp;
	char    *cp2;
	int     l;

	while ( ( cp = (char *) strstr( file, "//") ) != (char *) 0 )
	{
		for ( cp2 = cp + 2; *cp2 == '/'; ++cp2 )
			continue;
		(void) strcpy( cp + 1, cp2 );
	}

	while ( ( cp = (char*) strstr( file, "/../" ) ) != (char*) 0 )
	{
		for ( cp2 = cp - 1; cp2 >= file && *cp2 != '/'; --cp2 )
			continue;
		if ( cp2 < file )
			break;
		(void) strcpy( cp2, cp + 3 );
	}

	while ( ( l = strlen( file ) ) > 3 && memcmp( ( cp = file + l - 3 ), "/..", 3 ) == 0 )
	{
		for ( cp2 = cp - 1; cp2 >= file && *cp2 != '/'; --cp2 )
			continue;
		if ( cp2 < file )
			break;
		*cp2 = '\0';
	}
}

/* url ڵ带  ʿ  ó */
int http_hexit( char c )
{
	if ( c >= '0' && c <= '9' )
		return c - '0';
	if ( c >= 'a' && c <= 'f' )
		return c - 'a' + 10;
	if ( c >= 'A' && c <= 'F' )
		return c - 'A' + 10;
	return 0;
}
