#include <header.h>


/*  ͸ Ѵ */
int send_response( int sockfd, char *buf, int buf_len )
{
	int res;
	int idx;

	res = 1;
	idx = 0;

	//printf("%s\n",buf);

	while ( res > 0 )
	{
		res = write( sockfd, &(buf[idx]), buf_len);
		if ( res < 0 )
			return -1;
		
		buf_len -= res;
		idx += res;
	}
	return 0;
}

#if !defined(__APPLE__)

/*  ڸ  sendfile  */
int sendfile_response( int sockfd, int readfd, size_t readfd_len )
{
	off_t		offset = 0;
#ifdef __NONBLOCK
	struct pollfd	pollfd;

	pollfd.fd = sockfd;
	pollfd.events = POLLOUT;
#endif
	while ( offset < readfd_len )
	{
#ifdef __NONBLOCK
		if ( poll( &pollfd, 1, 500 ) > 0 )
		{
#endif
			if ( sendfile( sockfd, readfd, &offset, readfd_len ) <= 0 )
				return -1;
#ifdef __NONBLOCK
		}
#endif
	}
	return 0;
}

#else

int sendfile_response( int sockfd, int readfd, size_t readfd_len )
{
	char	buf[1024*32];
	int	read_res;
	int	write_res;
	int	write_idx;
	size_t	send_len=0;

	while ( send_len < readfd_len )
	{
		read_res = read( readfd, &buf, 1024*32 );
		if ( read_res < 0 )
			return -1;
		write_idx = 0;
		while ( read_res > 0 )
		{
			write_res = write( sockfd, &(buf[write_idx]), read_res );
			if ( write_res < 0 )
				return -1;
			write_idx += write_res;
			read_res -= write_res;
		}
		send_len += write_idx;
	}
	return 0;
}
#endif

size_t write_file( char *filename, char *buf, size_t buf_len )
{
	FILE	*stream;
	size_t	result;

	stream = fopen( filename, "w" );
	result = fwrite( buf, buf_len, 1, stream );
	fclose( stream );
	return result;
}

/* pollfd  Ѵ */
void set_pollfd( struct pollfd *pollfd, int fd, short events )
{
	pollfd->fd = fd;
	pollfd->events = events;
	return;
}

/*    ¸  filestat Ѵ */
int open_real_file( char *filename, struct stat *filestat )
{
	int fd, tmp;

	fd = open( filename, O_RDONLY );
	if ( fd < 0 )
		return -1;

	tmp = fstat( fd, filestat );
	if ( tmp >= 0 && ( S_ISREG( filestat->st_mode ) || S_ISLNK( filestat->st_mode ) ) )
		return fd;

	close( fd );
	return -1;
}


